<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { DynamicScroller } from 'vue-virtual-scroller';
  import { ProductFilteringControlKey } from '~/helpers/injection';

  const injection = inject(ProductFilteringControlKey);

  const emits = defineEmits<{
    (e: 'remove', id: string): void;
    (e: 'loadMore'): void;
  }>();

  const props = withDefaults(
    defineProps<{
      products: Product[];
      isLoadingMore?: boolean;
    }>(),
    {
      isLoadingMore: false,
    },
  );

  const scroller = ref<any>();
  const itemSize = ref(129);
  const initializing = ref(true);

  onMounted(() => {
    useInfiniteScroll(
      scroller.value.$refs.scroller.listenerTarget,
      () => {
        if (props.isLoadingMore || initializing.value) return;
        nextTick(() => {
          emits('loadMore');
        });
      },
      { distance: 10, interval: 1000 },
    );
    initializing.value = false;
  });
</script>

<template>
  <DynamicScroller ref="scroller" :items="products" :min-item-size="itemSize" page-mode>
    <template #default="{ item, index, active }">
      <DynamicScrollerItem :item="item" :active="active" :data-index="index">
        <InlineSelectedProductItem
          :product="item"
          :show-bookmark-shortcut="injection?.showBookmarkShortcut"
          @remove="injection?.remove({ [item.id]: true }, true)"
        />
      </DynamicScrollerItem>
    </template>
  </DynamicScroller>

  <!-- show loading state -->
  <SwLoading v-if="props.isLoadingMore" class="py-4" />
</template>
